Index: drivers/filesystems/btrfs/fileinfo.c
===================================================================
--- drivers/filesystems/btrfs/fileinfo.c	(révision 75772)
+++ drivers/filesystems/btrfs/fileinfo.c	(copie de travail)
@@ -2070,42 +1924,34 @@
                 ExFreePool(data);
                 return STATUS_INSUFFICIENT_RESOURCES;
             }
-            
+
             if (fcb->adsdata.Buffer) {
                 RtlCopyMemory(data, fcb->adsdata.Buffer, fcb->adsdata.Length);
                 ExFreePool(fcb->adsdata.Buffer);
             }
-            
+
             fcb->adsdata.Buffer = data;
             fcb->adsdata.MaximumLength = end;
         }
-        
+
         RtlZeroMemory(&fcb->adsdata.Buffer[fcb->adsdata.Length], end - fcb->adsdata.Length);
-        
+
         fcb->adsdata.Length = end;
     }
-    
+
     mark_fcb_dirty(fcb);
-    
+
     fcb->Header.AllocationSize.QuadPart = end;
     fcb->Header.FileSize.QuadPart = end;
     fcb->Header.ValidDataLength.QuadPart = end;
 
-    if (FileObject) {
-        ccfs.AllocationSize = fcb->Header.AllocationSize;
-        ccfs.FileSize = fcb->Header.FileSize;
-        ccfs.ValidDataLength = fcb->Header.ValidDataLength;
-
-        CcSetFileSizes(FileObject, &ccfs);
-    }
-    
     KeQuerySystemTime(&time);
     win_time_to_unix(time, &now);
-    
+
     fileref->parent->fcb->inode_item.transid = Vcb->superblock.generation;
     fileref->parent->fcb->inode_item.sequence++;
     fileref->parent->fcb->inode_item.st_ctime = now;
-    
+
     fileref->parent->fcb->inode_item_changed = TRUE;
     mark_fcb_dirty(fileref->parent->fcb);
 
@@ -2115,7 +1961,7 @@
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS STDCALL set_end_of_file_information(device_extension* Vcb, PIRP Irp, PFILE_OBJECT FileObject, BOOL advance_only) {
+static NTSTATUS set_end_of_file_information(device_extension* Vcb, PIRP Irp, PFILE_OBJECT FileObject, BOOL advance_only, BOOL prealloc) {
     FILE_END_OF_FILE_INFORMATION* feofi = Irp->AssociatedIrp.SystemBuffer;
     fcb* fcb = FileObject->FsContext;
     ccb* ccb = FileObject->FsContext2;
@@ -2125,134 +1971,161 @@
     CC_FILE_SIZES ccfs;
     LIST_ENTRY rollback;
     BOOL set_size = FALSE;
-    
+    ULONG filter;
+
     if (!fileref) {
         ERR("fileref is NULL\n");
         return STATUS_INVALID_PARAMETER;
     }
-    
+
     InitializeListHead(&rollback);
-    
+
     ExAcquireResourceSharedLite(&Vcb->tree_lock, TRUE);
-    
+
     ExAcquireResourceExclusiveLite(fcb->Header.Resource, TRUE);
-    
+
     if (fileref ? fileref->deleted : fcb->deleted) {
         Status = STATUS_FILE_CLOSED;
         goto end;
     }
-    
+
     if (fcb->ads) {
-        Status = stream_set_end_of_file_information(Vcb, feofi->EndOfFile.QuadPart, fcb, fileref, FileObject, advance_only, &rollback);
+        if (feofi->EndOfFile.QuadPart > 0xffff) {
+            Status = STATUS_DISK_FULL;
+            goto end;
+        }
+
+        if (feofi->EndOfFile.QuadPart < 0) {
+            Status = STATUS_INVALID_PARAMETER;
+            goto end;
+        }
+
+        Status = stream_set_end_of_file_information(Vcb, (UINT16)feofi->EndOfFile.QuadPart, fcb, fileref, advance_only);
+
+        if (NT_SUCCESS(Status)) {
+            ccfs.AllocationSize = fcb->Header.AllocationSize;
+            ccfs.FileSize = fcb->Header.FileSize;
+            ccfs.ValidDataLength = fcb->Header.ValidDataLength;
+            set_size = TRUE;
+        }
+
+        filter = FILE_NOTIFY_CHANGE_SIZE;
+
+        if (!ccb->user_set_write_time) {
+            KeQuerySystemTime(&time);
+            win_time_to_unix(time, &fileref->parent->fcb->inode_item.st_mtime);
+            filter |= FILE_NOTIFY_CHANGE_LAST_WRITE;
+
+            fileref->parent->fcb->inode_item_changed = TRUE;
+            mark_fcb_dirty(fileref->parent->fcb);
+        }
+
+        send_notification_fcb(fileref->parent, filter, FILE_ACTION_MODIFIED, &fileref->dc->name);
+
         goto end;
     }
-    
+
     TRACE("file: %S\n", file_desc(FileObject));
     TRACE("paging IO: %s\n", Irp->Flags & IRP_PAGING_IO ? "TRUE" : "FALSE");
     TRACE("FileObject: AllocationSize = %llx, FileSize = %llx, ValidDataLength = %llx\n",
         fcb->Header.AllocationSize.QuadPart, fcb->Header.FileSize.QuadPart, fcb->Header.ValidDataLength.QuadPart);
-    
-//     int3;
+
     TRACE("setting new end to %llx bytes (currently %llx)\n", feofi->EndOfFile.QuadPart, fcb->inode_item.st_size);
-    
-//     if (feofi->EndOfFile.QuadPart==0x36c000)
-//         int3;
-    
-    if (feofi->EndOfFile.QuadPart < fcb->inode_item.st_size) {
+
+    if ((UINT64)feofi->EndOfFile.QuadPart < fcb->inode_item.st_size) {
         if (advance_only) {
             Status = STATUS_SUCCESS;
             goto end;
         }
-        
+
         TRACE("truncating file to %llx bytes\n", feofi->EndOfFile.QuadPart);
-        
+
         if (!MmCanFileBeTruncated(&fcb->nonpaged->segment_object, &feofi->EndOfFile)) {
             Status = STATUS_USER_MAPPED_FILE;
             goto end;
         }
-        
+
         Status = truncate_file(fcb, feofi->EndOfFile.QuadPart, Irp, &rollback);
         if (!NT_SUCCESS(Status)) {
             ERR("error - truncate_file failed\n");
             goto end;
         }
-    } else if (feofi->EndOfFile.QuadPart > fcb->inode_item.st_size) {
+    } else if ((UINT64)feofi->EndOfFile.QuadPart > fcb->inode_item.st_size) {
         if (Irp->Flags & IRP_PAGING_IO) {
             TRACE("paging IO tried to extend file size\n");
             Status = STATUS_SUCCESS;
             goto end;
         }
-        
+
         TRACE("extending file to %llx bytes\n", feofi->EndOfFile.QuadPart);
-        
-        Status = extend_file(fcb, fileref, feofi->EndOfFile.QuadPart, TRUE, NULL, &rollback);
+
+        Status = extend_file(fcb, fileref, feofi->EndOfFile.QuadPart, prealloc, NULL, &rollback);
         if (!NT_SUCCESS(Status)) {
             ERR("error - extend_file failed\n");
             goto end;
         }
     }
-    
+
     ccfs.AllocationSize = fcb->Header.AllocationSize;
     ccfs.FileSize = fcb->Header.FileSize;
     ccfs.ValidDataLength = fcb->Header.ValidDataLength;
     set_size = TRUE;
-    
+
+    filter = FILE_NOTIFY_CHANGE_SIZE;
+
     if (!ccb->user_set_write_time) {
         KeQuerySystemTime(&time);
         win_time_to_unix(time, &fcb->inode_item.st_mtime);
+        filter |= FILE_NOTIFY_CHANGE_LAST_WRITE;
     }
-    
+
     fcb->inode_item_changed = TRUE;
     mark_fcb_dirty(fcb);
-    send_notification_fcb(fileref, FILE_NOTIFY_CHANGE_LAST_WRITE | FILE_NOTIFY_CHANGE_SIZE, FILE_ACTION_MODIFIED);
+    send_notification_fcb(fileref, filter, FILE_ACTION_MODIFIED, NULL);
 
     Status = STATUS_SUCCESS;
 
 end:
     if (NT_SUCCESS(Status))
-        clear_rollback(Vcb, &rollback);
+        clear_rollback(&rollback);
     else
         do_rollback(Vcb, &rollback);
 
     ExReleaseResourceLite(fcb->Header.Resource);
-    
-    if (set_size)
-        CcSetFileSizes(FileObject, &ccfs);
-    
+
+    if (set_size) {
+        _SEH2_TRY {
+            CcSetFileSizes(FileObject, &ccfs);
+        } _SEH2_EXCEPT (EXCEPTION_EXECUTE_HANDLER) {
+            Status = _SEH2_GetExceptionCode();
+        } _SEH2_END;
+
+        if (!NT_SUCCESS(Status))
+            ERR("CcSetFileSizes threw exception %08x\n", Status);
+    }
+
     ExReleaseResourceLite(&Vcb->tree_lock);
-    
+
     return Status;
 }
 
-// static NTSTATUS STDCALL set_allocation_information(device_extension* Vcb, PIRP Irp, PFILE_OBJECT FileObject) {
-//     FILE_ALLOCATION_INFORMATION* fai = (FILE_ALLOCATION_INFORMATION*)Irp->AssociatedIrp.SystemBuffer;
-//     fcb* fcb = FileObject->FsContext;
-//     
-//     FIXME("FIXME\n");
-//     ERR("fcb = %p (%.*S)\n", fcb, fcb->full_filename.Length / sizeof(WCHAR), fcb->full_filename.Buffer);
-//     ERR("AllocationSize = %llx\n", fai->AllocationSize.QuadPart);
-//     
-//     return STATUS_NOT_IMPLEMENTED;
-// }
+static NTSTATUS set_position_information(PFILE_OBJECT FileObject, PIRP Irp) {
+    FILE_POSITION_INFORMATION* fpi = (FILE_POSITION_INFORMATION*)Irp->AssociatedIrp.SystemBuffer;
 
-static NTSTATUS STDCALL set_position_information(device_extension* Vcb, PIRP Irp, PFILE_OBJECT FileObject) {
-    FILE_POSITION_INFORMATION* fpi = (FILE_POSITION_INFORMATION*)Irp->AssociatedIrp.SystemBuffer;
-    
     TRACE("setting the position on %S to %llx\n", file_desc(FileObject), fpi->CurrentByteOffset.QuadPart);
-    
+
     // FIXME - make sure aligned for FO_NO_INTERMEDIATE_BUFFERING
-    
+
     FileObject->CurrentByteOffset = fpi->CurrentByteOffset;
-    
+
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS STDCALL set_link_information(device_extension* Vcb, PIRP Irp, PFILE_OBJECT FileObject, PFILE_OBJECT tfo) {
+static NTSTATUS set_link_information(device_extension* Vcb, PIRP Irp, PFILE_OBJECT FileObject, PFILE_OBJECT tfo) {
     FILE_LINK_INFORMATION* fli = Irp->AssociatedIrp.SystemBuffer;
     fcb *fcb = FileObject->FsContext, *tfofcb, *parfcb;
     ccb* ccb = FileObject->FsContext2;
     file_ref *fileref = ccb ? ccb->fileref : NULL, *oldfileref = NULL, *related = NULL, *fr2 = NULL;
-    UINT64 index;
     WCHAR* fn;
     ULONG fnlen, utf8len;
     UNICODE_STRING fnus;
@@ -2265,40 +2138,40 @@
     ACCESS_MASK access;
     SECURITY_SUBJECT_CONTEXT subjcont;
     dir_child* dc = NULL;
-    
+
     InitializeListHead(&rollback);
-    
+
     // FIXME - check fli length
     // FIXME - don't ignore fli->RootDirectory
-    
+
     TRACE("ReplaceIfExists = %x\n", fli->ReplaceIfExists);
     TRACE("RootDirectory = %p\n", fli->RootDirectory);
     TRACE("FileNameLength = %x\n", fli->FileNameLength);
     TRACE("FileName = %.*S\n", fli->FileNameLength / sizeof(WCHAR), fli->FileName);
-    
+
     fn = fli->FileName;
     fnlen = fli->FileNameLength / sizeof(WCHAR);
-    
+
     if (!tfo) {
         if (!fileref || !fileref->parent) {
             ERR("no fileref set and no directory given\n");
             return STATUS_INVALID_PARAMETER;
         }
-        
+
         parfcb = fileref->parent->fcb;
         tfofcb = NULL;
     } else {
         LONG i;
-        
+
         tfofcb = tfo->FsContext;
         parfcb = tfofcb;
-        
+
         while (fnlen > 0 && (fli->FileName[fnlen - 1] == '/' || fli->FileName[fnlen - 1] == '\\'))
             fnlen--;
-        
+
         if (fnlen == 0)
             return STATUS_INVALID_PARAMETER;
-        
+
         for (i = fnlen - 1; i >= 0; i--) {
             if (fli->FileName[i] == '\\' || fli->FileName[i] == '/') {
                 fn = &fli->FileName[i+1];
@@ -2307,33 +2180,38 @@
             }
         }
     }
-    
+
     ExAcquireResourceSharedLite(&Vcb->tree_lock, TRUE);
     ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
     ExAcquireResourceExclusiveLite(fcb->Header.Resource, TRUE);
-    
+
     if (fcb->type == BTRFS_TYPE_DIRECTORY) {
         WARN("tried to create hard link on directory\n");
         Status = STATUS_FILE_IS_A_DIRECTORY;
         goto end;
     }
-    
+
     if (fcb->ads) {
         WARN("tried to create hard link on stream\n");
         Status = STATUS_INVALID_PARAMETER;
         goto end;
     }
-    
+
+    if (fcb->inode_item.st_nlink >= 65535) {
+        Status = STATUS_TOO_MANY_LINKS;
+        goto end;
+    }
+
     fnus.Buffer = fn;
-    fnus.Length = fnus.MaximumLength = fnlen * sizeof(WCHAR);
-    
+    fnus.Length = fnus.MaximumLength = (UINT16)(fnlen * sizeof(WCHAR));
+
     TRACE("fnus = %.*S\n", fnus.Length / sizeof(WCHAR), fnus.Buffer);
-    
+
     Status = RtlUnicodeToUTF8N(NULL, 0, &utf8len, fn, (ULONG)fnlen * sizeof(WCHAR));
     if (!NT_SUCCESS(Status))
         goto end;
-    
-    utf8.MaximumLength = utf8.Length = utf8len;
+
+    utf8.MaximumLength = utf8.Length = (UINT16)utf8len;
     utf8.Buffer = ExAllocatePoolWithTag(PagedPool, utf8.MaximumLength, ALLOC_TAG);
     if (!utf8.Buffer) {
         ERR("out of memory\n");
@@ -2340,14 +2218,14 @@
         Status = STATUS_INSUFFICIENT_RESOURCES;
         goto end;
     }
-    
+
     Status = RtlUnicodeToUTF8N(utf8.Buffer, utf8len, &utf8len, fn, (ULONG)fnlen * sizeof(WCHAR));
     if (!NT_SUCCESS(Status))
         goto end;
-    
+
     if (tfo && tfo->FsContext2) {
         struct _ccb* relatedccb = tfo->FsContext2;
-        
+
         related = relatedccb->fileref;
         increase_fileref_refcount(related);
     }
@@ -2357,7 +2235,7 @@
     if (NT_SUCCESS(Status)) {
         if (!oldfileref->deleted) {
             WARN("destination file %S already exists\n", file_desc_fileref(oldfileref));
-        
+
             if (!fli->ReplaceIfExists) {
                 Status = STATUS_OBJECT_NAME_COLLISION;
                 goto end;
@@ -2369,7 +2247,7 @@
                 Status = STATUS_ACCESS_DENIED;
                 goto end;
             }
-            
+
             if (oldfileref->fcb->type == BTRFS_TYPE_DIRECTORY) {
                 WARN("trying to overwrite directory\n");
                 Status = STATUS_ACCESS_DENIED;
@@ -2376,11 +2254,11 @@
                 goto end;
             }
         } else {
-            free_fileref(oldfileref);
+            free_fileref(Vcb, oldfileref);
             oldfileref = NULL;
         }
     }
-    
+
     if (!related) {
         Status = open_fileref(Vcb, &related, &fnus, NULL, TRUE, NULL, NULL, PagedPool, ccb->case_sensitive, Irp);
 
@@ -2389,24 +2267,24 @@
             goto end;
         }
     }
-    
+
     SeCaptureSubjectContext(&subjcont);
 
     if (!SeAccessCheck(related->fcb->sd, &subjcont, FALSE, FILE_ADD_FILE, 0, NULL,
                        IoGetFileObjectGenericMapping(), Irp->RequestorMode, &access, &Status)) {
         SeReleaseSubjectContext(&subjcont);
-        WARN("SeAccessCheck failed, returning %08x\n", Status);
+        TRACE("SeAccessCheck failed, returning %08x\n", Status);
         goto end;
     }
 
     SeReleaseSubjectContext(&subjcont);
-    
+
     if (fcb->subvol != parfcb->subvol) {
         WARN("can't create hard link over subvolume boundary\n");
         Status = STATUS_INVALID_PARAMETER;
         goto end;
     }
-    
+
     if (oldfileref) {
         SeCaptureSubjectContext(&subjcont);
 
@@ -2413,12 +2291,12 @@
         if (!SeAccessCheck(oldfileref->fcb->sd, &subjcont, FALSE, DELETE, 0, NULL,
                            IoGetFileObjectGenericMapping(), Irp->RequestorMode, &access, &Status)) {
             SeReleaseSubjectContext(&subjcont);
-            WARN("SeAccessCheck failed, returning %08x\n", Status);
+            TRACE("SeAccessCheck failed, returning %08x\n", Status);
             goto end;
         }
 
         SeReleaseSubjectContext(&subjcont);
-        
+
         Status = delete_fileref(oldfileref, NULL, Irp, &rollback);
         if (!NT_SUCCESS(Status)) {
             ERR("delete_fileref returned %08x\n", Status);
@@ -2425,48 +2303,26 @@
             goto end;
         }
     }
-    
-    Status = fcb_get_last_dir_index(related->fcb, &index, Irp);
-    if (!NT_SUCCESS(Status)) {
-        ERR("fcb_get_last_dir_index returned %08x\n", Status);
-        goto end;
-    }
-    
-    fr2 = create_fileref();
-    
+
+    fr2 = create_fileref(Vcb);
+
     fr2->fcb = fcb;
     fcb->refcount++;
-    
-    fr2->utf8 = utf8;
-    fr2->index = index;
+
     fr2->created = TRUE;
     fr2->parent = related;
-    
-    fr2->filepart.Buffer = ExAllocatePoolWithTag(PagedPool, fnus.Length, ALLOC_TAG);
-    if (!fr2->filepart.Buffer) {
-        ERR("out of memory\n");
-        Status = STATUS_INSUFFICIENT_RESOURCES;
-        goto end;
-    }
-    
-    fr2->filepart.Length = fr2->filepart.MaximumLength = fnus.Length;
-    RtlCopyMemory(fr2->filepart.Buffer, fnus.Buffer, fnus.Length);
-    
-    Status = RtlUpcaseUnicodeString(&fr2->filepart_uc, &fr2->filepart, TRUE);
-    if (!NT_SUCCESS(Status)) {
-        ERR("RtlUpcaseUnicodeString returned %08x\n", Status);
-        goto end;
-    }
-      
-    insert_fileref_child(related, fr2, TRUE);
-    
-    Status = add_dir_child(related->fcb, fcb->inode, FALSE, index, &utf8, &fr2->filepart, &fr2->filepart_uc, fcb->type, &dc);
+
+    Status = add_dir_child(related->fcb, fcb->inode, FALSE, &utf8, &fnus, fcb->type, &dc);
     if (!NT_SUCCESS(Status))
         WARN("add_dir_child returned %08x\n", Status);
-    
+
     fr2->dc = dc;
     dc->fileref = fr2;
 
+    ExAcquireResourceExclusiveLite(&related->nonpaged->children_lock, TRUE);
+    InsertTailList(&related->children, &fr2->list_entry);
+    ExReleaseResourceLite(&related->nonpaged->children_lock);
+
     // add hardlink for existing fileref, if it's not there already
     if (IsListEmpty(&fcb->hardlinks)) {
         hl = ExAllocatePoolWithTag(PagedPool, sizeof(hardlink), ALLOC_TAG);
@@ -2475,13 +2331,13 @@
             Status = STATUS_INSUFFICIENT_RESOURCES;
             goto end;
         }
-        
+
         hl->parent = fileref->parent->fcb->inode;
-        hl->index = fileref->index;
-        
-        hl->name.Length = hl->name.MaximumLength = fileref->filepart.Length;
-        hl->name.Buffer = ExAllocatePoolWithTag(PagedPool, hl->name.MaximumLength, ALLOC_TAG);
-        
+        hl->index = fileref->dc->index;
+
+        hl->name.Length = hl->name.MaximumLength = fnus.Length;
+        hl->name.Buffer = ExAllocatePoolWithTag(PagedPool, fnus.Length, ALLOC_TAG);
+
         if (!hl->name.Buffer) {
             ERR("out of memory\n");
             ExFreePool(hl);
@@ -2488,12 +2344,12 @@
             Status = STATUS_INSUFFICIENT_RESOURCES;
             goto end;
         }
-        
-        RtlCopyMemory(hl->name.Buffer, fileref->filepart.Buffer, fileref->filepart.Length);
-        
-        hl->utf8.Length = hl->utf8.MaximumLength = fileref->utf8.Length;
+
+        RtlCopyMemory(hl->name.Buffer, fnus.Buffer, fnus.Length);
+
+        hl->utf8.Length = hl->utf8.MaximumLength = fileref->dc->utf8.Length;
         hl->utf8.Buffer = ExAllocatePoolWithTag(PagedPool, hl->utf8.MaximumLength, ALLOC_TAG);
-        
+
         if (!hl->utf8.Buffer) {
             ERR("out of memory\n");
             ExFreePool(hl->name.Buffer);
@@ -2501,12 +2357,12 @@
             Status = STATUS_INSUFFICIENT_RESOURCES;
             goto end;
         }
-        
-        RtlCopyMemory(hl->utf8.Buffer, fileref->utf8.Buffer, fileref->utf8.Length);
-        
+
+        RtlCopyMemory(hl->utf8.Buffer, fileref->dc->utf8.Buffer, fileref->dc->utf8.Length);
+
         InsertTailList(&fcb->hardlinks, &hl->list_entry);
     }
-    
+
     hl = ExAllocatePoolWithTag(PagedPool, sizeof(hardlink), ALLOC_TAG);
     if (!hl) {
         ERR("out of memory\n");
@@ -2513,13 +2369,13 @@
         Status = STATUS_INSUFFICIENT_RESOURCES;
         goto end;
     }
-    
+
     hl->parent = related->fcb->inode;
-    hl->index = index;
-    
+    hl->index = dc->index;
+
     hl->name.Length = hl->name.MaximumLength = fnus.Length;
     hl->name.Buffer = ExAllocatePoolWithTag(PagedPool, hl->name.MaximumLength, ALLOC_TAG);
-    
+
     if (!hl->name.Buffer) {
         ERR("out of memory\n");
         ExFreePool(hl);
@@ -2526,12 +2382,12 @@
         Status = STATUS_INSUFFICIENT_RESOURCES;
         goto end;
     }
-    
+
     RtlCopyMemory(hl->name.Buffer, fnus.Buffer, fnus.Length);
-    
+
     hl->utf8.Length = hl->utf8.MaximumLength = utf8.Length;
     hl->utf8.Buffer = ExAllocatePoolWithTag(PagedPool, hl->utf8.MaximumLength, ALLOC_TAG);
-    
+
     if (!hl->utf8.Buffer) {
         ERR("out of memory\n");
         ExFreePool(hl->name.Buffer);
@@ -2539,31 +2395,32 @@
         Status = STATUS_INSUFFICIENT_RESOURCES;
         goto end;
     }
-    
+
     RtlCopyMemory(hl->utf8.Buffer, utf8.Buffer, utf8.Length);
-    
+    ExFreePool(utf8.Buffer);
+
     InsertTailList(&fcb->hardlinks, &hl->list_entry);
-    
+
     mark_fileref_dirty(fr2);
-    free_fileref(fr2);
-    
+    free_fileref(Vcb, fr2);
+
     // update inode's INODE_ITEM
-    
+
     KeQuerySystemTime(&time);
     win_time_to_unix(time, &now);
-    
+
     fcb->inode_item.transid = Vcb->superblock.generation;
     fcb->inode_item.sequence++;
     fcb->inode_item.st_nlink++;
-    
+
     if (!ccb->user_set_change_time)
         fcb->inode_item.st_ctime = now;
-    
+
     fcb->inode_item_changed = TRUE;
     mark_fcb_dirty(fcb);
-    
+
     // update parent's INODE_ITEM
-    
+
     parfcb->inode_item.transid = Vcb->superblock.generation;
     TRACE("parfcb->inode_item.st_size (inode %llx) was %llx\n", parfcb->inode, parfcb->inode_item.st_size);
     parfcb->inode_item.st_size += 2 * utf8len;
@@ -2570,26 +2427,26 @@
     TRACE("parfcb->inode_item.st_size (inode %llx) now %llx\n", parfcb->inode, parfcb->inode_item.st_size);
     parfcb->inode_item.sequence++;
     parfcb->inode_item.st_ctime = now;
-    
+
     parfcb->inode_item_changed = TRUE;
     mark_fcb_dirty(parfcb);
-    
-    send_notification_fileref(fr2, FILE_NOTIFY_CHANGE_FILE_NAME, FILE_ACTION_ADDED);
 
+    send_notification_fileref(fr2, FILE_NOTIFY_CHANGE_FILE_NAME, FILE_ACTION_ADDED, NULL);
+
     Status = STATUS_SUCCESS;
-    
+
 end:
     if (oldfileref)
-        free_fileref(oldfileref);
-    
+        free_fileref(Vcb, oldfileref);
+
     if (!NT_SUCCESS(Status) && related)
-        free_fileref(related);
-    
+        free_fileref(Vcb, related);
+
     if (!NT_SUCCESS(Status) && fr2)
-        free_fileref(fr2);
-    
+        free_fileref(Vcb, fr2);
+
     if (NT_SUCCESS(Status))
-        clear_rollback(Vcb, &rollback);
+        clear_rollback(&rollback);
     else
         do_rollback(Vcb, &rollback);
 
@@ -2596,12 +2453,109 @@
     ExReleaseResourceLite(fcb->Header.Resource);
     ExReleaseResourceLite(&Vcb->fcb_lock);
     ExReleaseResourceLite(&Vcb->tree_lock);
-    
+
     return Status;
 }
 
-NTSTATUS STDCALL drv_set_information(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp) {
+static NTSTATUS set_valid_data_length_information(device_extension* Vcb, PIRP Irp, PFILE_OBJECT FileObject) {
+    FILE_VALID_DATA_LENGTH_INFORMATION* fvdli = Irp->AssociatedIrp.SystemBuffer;
+    PIO_STACK_LOCATION IrpSp = IoGetCurrentIrpStackLocation(Irp);
+    fcb* fcb = FileObject->FsContext;
+    ccb* ccb = FileObject->FsContext2;
+    file_ref* fileref = ccb ? ccb->fileref : NULL;
     NTSTATUS Status;
+    LARGE_INTEGER time;
+    CC_FILE_SIZES ccfs;
+    LIST_ENTRY rollback;
+    BOOL set_size = FALSE;
+    ULONG filter;
+
+    if (IrpSp->Parameters.SetFile.Length < sizeof(FILE_VALID_DATA_LENGTH_INFORMATION)) {
+        ERR("input buffer length was %u, expected %u\n", IrpSp->Parameters.SetFile.Length, sizeof(FILE_VALID_DATA_LENGTH_INFORMATION));
+        return STATUS_INVALID_PARAMETER;
+    }
+
+    if (!fileref) {
+        ERR("fileref is NULL\n");
+        return STATUS_INVALID_PARAMETER;
+    }
+
+    InitializeListHead(&rollback);
+
+    ExAcquireResourceSharedLite(&Vcb->tree_lock, TRUE);
+
+    ExAcquireResourceExclusiveLite(fcb->Header.Resource, TRUE);
+
+    if (fcb->atts & FILE_ATTRIBUTE_SPARSE_FILE) {
+        Status = STATUS_INVALID_PARAMETER;
+        goto end;
+    }
+
+    if (fvdli->ValidDataLength.QuadPart <= fcb->Header.ValidDataLength.QuadPart || fvdli->ValidDataLength.QuadPart > fcb->Header.FileSize.QuadPart) {
+        TRACE("invalid VDL of %llu (current VDL = %llu, file size = %llu)\n", fvdli->ValidDataLength.QuadPart,
+              fcb->Header.ValidDataLength.QuadPart, fcb->Header.FileSize.QuadPart);
+        Status = STATUS_INVALID_PARAMETER;
+        goto end;
+    }
+
+    if (fileref ? fileref->deleted : fcb->deleted) {
+        Status = STATUS_FILE_CLOSED;
+        goto end;
+    }
+
+    // This function doesn't really do anything - the fsctl can only increase the value of ValidDataLength,
+    // and we set it to the max anyway.
+
+    ccfs.AllocationSize = fcb->Header.AllocationSize;
+    ccfs.FileSize = fcb->Header.FileSize;
+    ccfs.ValidDataLength = fvdli->ValidDataLength;
+    set_size = TRUE;
+
+    filter = FILE_NOTIFY_CHANGE_SIZE;
+
+    if (!ccb->user_set_write_time) {
+        KeQuerySystemTime(&time);
+        win_time_to_unix(time, &fcb->inode_item.st_mtime);
+        filter |= FILE_NOTIFY_CHANGE_LAST_WRITE;
+    }
+
+    fcb->inode_item_changed = TRUE;
+    mark_fcb_dirty(fcb);
+
+    send_notification_fcb(fileref, filter, FILE_ACTION_MODIFIED, NULL);
+
+    Status = STATUS_SUCCESS;
+
+end:
+    if (NT_SUCCESS(Status))
+        clear_rollback(&rollback);
+    else
+        do_rollback(Vcb, &rollback);
+
+    ExReleaseResourceLite(fcb->Header.Resource);
+
+    if (set_size) {
+        _SEH2_TRY {
+            CcSetFileSizes(FileObject, &ccfs);
+        } _SEH2_EXCEPT (EXCEPTION_EXECUTE_HANDLER) {
+            Status = _SEH2_GetExceptionCode();
+        } _SEH2_END;
+
+        if (!NT_SUCCESS(Status))
+            ERR("CcSetFileSizes threw exception %08x\n", Status);
+        else
+            fcb->Header.AllocationSize = ccfs.AllocationSize;
+    }
+
+    ExReleaseResourceLite(&Vcb->tree_lock);
+
+    return Status;
+}
+
+_Dispatch_type_(IRP_MJ_SET_INFORMATION)
+_Function_class_(DRIVER_DISPATCH)
+NTSTATUS drv_set_information(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp) {
+    NTSTATUS Status;
     PIO_STACK_LOCATION IrpSp = IoGetCurrentIrpStackLocation(Irp);
     device_extension* Vcb = DeviceObject->DeviceExtension;
     fcb* fcb = IrpSp->FileObject->FsContext;
@@ -2609,44 +2563,47 @@
     BOOL top_level;
 
     FsRtlEnterFileSystem();
-    
+
     top_level = is_top_level(Irp);
-    
-    if (Vcb && Vcb->type == VCB_TYPE_PARTITION0) {
-        Status = part0_passthrough(DeviceObject, Irp);
-        goto exit;
+
+    Irp->IoStatus.Information = 0;
+
+    if (Vcb && Vcb->type == VCB_TYPE_VOLUME) {
+        Status = vol_set_information(DeviceObject, Irp);
+        goto end;
+    } else if (!Vcb || Vcb->type != VCB_TYPE_FS) {
+        Status = STATUS_INVALID_PARAMETER;
+        goto end;
     }
-    
+
     if (!(Vcb->Vpb->Flags & VPB_MOUNTED)) {
         Status = STATUS_ACCESS_DENIED;
         goto end;
     }
-    
+
     if (Vcb->readonly && IrpSp->Parameters.SetFile.FileInformationClass != FilePositionInformation) {
         Status = STATUS_MEDIA_WRITE_PROTECTED;
         goto end;
     }
-    
+
     if (!fcb) {
         ERR("no fcb\n");
         Status = STATUS_INVALID_PARAMETER;
         goto end;
     }
-    
+
     if (!ccb) {
         ERR("no ccb\n");
         Status = STATUS_INVALID_PARAMETER;
         goto end;
     }
-    
-    if (fcb->subvol->root_item.flags & BTRFS_SUBVOL_READONLY && IrpSp->Parameters.SetFile.FileInformationClass != FilePositionInformation &&
-        (fcb->inode != SUBVOL_ROOT_INODE || IrpSp->Parameters.SetFile.FileInformationClass != FileBasicInformation)) {
+
+    if (fcb != Vcb->dummy_fcb && is_subvol_readonly(fcb->subvol, Irp) && IrpSp->Parameters.SetFile.FileInformationClass != FilePositionInformation &&
+        (fcb->inode != SUBVOL_ROOT_INODE || (IrpSp->Parameters.SetFile.FileInformationClass != FileBasicInformation && IrpSp->Parameters.SetFile.FileInformationClass != FileRenameInformation))) {
         Status = STATUS_ACCESS_DENIED;
         goto end;
     }
 
-    Irp->IoStatus.Information = 0;
-    
     Status = STATUS_NOT_IMPLEMENTED;
 
     TRACE("set information\n");
@@ -2655,14 +2612,14 @@
         case FileAllocationInformation:
         {
             TRACE("FileAllocationInformation\n");
-            
+
             if (Irp->RequestorMode == UserMode && !(ccb->access & FILE_WRITE_DATA)) {
                 WARN("insufficient privileges\n");
                 Status = STATUS_ACCESS_DENIED;
                 break;
             }
-            
-            Status = set_end_of_file_information(Vcb, Irp, IrpSp->FileObject, FALSE);
+
+            Status = set_end_of_file_information(Vcb, Irp, IrpSp->FileObject, FALSE, TRUE);
             break;
         }
 
@@ -2669,15 +2626,15 @@
         case FileBasicInformation:
         {
             TRACE("FileBasicInformation\n");
-            
+
             if (Irp->RequestorMode == UserMode && !(ccb->access & FILE_WRITE_ATTRIBUTES)) {
                 WARN("insufficient privileges\n");
                 Status = STATUS_ACCESS_DENIED;
                 break;
             }
-            
+
             Status = set_basic_information(Vcb, Irp, IrpSp->FileObject);
-            
+
             break;
         }
 
@@ -2684,15 +2641,15 @@
         case FileDispositionInformation:
         {
             TRACE("FileDispositionInformation\n");
-            
+
             if (Irp->RequestorMode == UserMode && !(ccb->access & DELETE)) {
                 WARN("insufficient privileges\n");
                 Status = STATUS_ACCESS_DENIED;
                 break;
             }
-            
+
             Status = set_disposition_information(Vcb, Irp, IrpSp->FileObject);
-            
+
             break;
         }
 
@@ -2699,15 +2656,15 @@
         case FileEndOfFileInformation:
         {
             TRACE("FileEndOfFileInformation\n");
-            
+
             if (Irp->RequestorMode == UserMode && !(ccb->access & (FILE_WRITE_DATA | FILE_APPEND_DATA))) {
                 WARN("insufficient privileges\n");
                 Status = STATUS_ACCESS_DENIED;
                 break;
             }
-            
-            Status = set_end_of_file_information(Vcb, Irp, IrpSp->FileObject, IrpSp->Parameters.SetFile.AdvanceOnly);
-            
+
+            Status = set_end_of_file_information(Vcb, Irp, IrpSp->FileObject, IrpSp->Parameters.SetFile.AdvanceOnly, FALSE);
+
             break;
         }
 
@@ -2717,13 +2674,9 @@
             break;
 
         case FilePositionInformation:
-        {
             TRACE("FilePositionInformation\n");
-            
-            Status = set_position_information(Vcb, Irp, IrpSp->FileObject);
-            
+            Status = set_position_information(IrpSp->FileObject, Irp);
             break;
-        }
 
         case FileRenameInformation:
             TRACE("FileRenameInformation\n");
